using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.Drawing.Text;
using System.Xml;
using BlogEngine.Core;

public partial class image : System.Web.UI.Page
{
    int qq = 0;
    private string dataSource;
    protected void Page_Load(object sender, EventArgs e)
    {
        dataSource = System.Web.HttpContext.Current.Server.MapPath(BlogSettings.Instance.StorageLocation) + "quotes.xml";
        Random RandomClass = new Random();
        int RandomNumber;
        Bitmap bitMapImage;
        SolidBrush sb = new SolidBrush(Color.FromArgb(2, 94, 8));
        string file = "signatures/";          
        RandomNumber = RandomClass.Next(1, 20);
        int x;
        if (RandomNumber % 2 == 0)
        {
            file += "1/";
            x = 0;
        }
        else
        {
            file += "2/";
            x = 138;
        }     
        
        string[] filenames=Directory.GetFiles(Server.MapPath(file));
        int flg=1;
		while(flg==1)
		{
	        RandomNumber = RandomClass.Next(1,filenames.Length);
	        file = filenames[RandomNumber].ToString();
	        if (file.Substring(file.Length - 4) != ".jpg")
	        {
	            flg=1;
	        }
			else
			{
				flg=0;
			}
		}
        bitMapImage = new System.Drawing.Bitmap(file);

        int wdth = bitMapImage.Width;
        Graphics graphicImage = Graphics.FromImage(bitMapImage);

        graphicImage.InterpolationMode = InterpolationMode.HighQualityBicubic;
        graphicImage.SmoothingMode = SmoothingMode.HighQuality;
        graphicImage.PixelOffsetMode = PixelOffsetMode.HighQuality;
        graphicImage.TextRenderingHint = TextRenderingHint.SingleBitPerPixelGridFit;
        graphicImage.CompositingQuality = CompositingQuality.HighQuality;
        
        Font fnt = new Font("Trebuchet MS", 4, FontStyle.Bold);
        string[] quote = GetQuotes();
        for (int i = 0; i <= qq; i++)
        {
            if (i == qq)
            {
                if (x == 0)
                {
                    graphicImage.DrawString(quote[i].Trim(), fnt, sb, new Point(200 - (quote[i].Length * 4), ((i) * 17) + 5));
                }
                else
                {
                    graphicImage.DrawString(quote[i].Trim(), fnt, sb, new Point(350 - (quote[i].Length * 4), ((i) * 17) + 5));
                }
            }
            else if (i == 0)
            {
                graphicImage.DrawString(quote[i].Trim(), fnt, sb, new Point(0, ((i) * 17) + 5));
            }
            else
            {
                graphicImage.DrawString(quote[i].Trim(), fnt, sb, new Point(x, ((i) * 17) + 5));
            }
        }
        sb.Dispose();
        sb = new SolidBrush(Color.FromArgb(2, 8, 94));
        string[] a = new string[2];
        a = GetHtmlPage("http://api.hostip.info/get_html.php?ip=" + Request.ServerVariables["REMOTE_HOST"].ToString().Trim()).Split('\n');
        graphicImage.DrawString("Your Ip is " + Request.ServerVariables["REMOTE_HOST"].ToString() + " from " + a[0].Replace("Country: ", ""), fnt, sb, new Point(x, ((qq + 1) * 17) + 5));
        graphicImage.DrawString("You are using " + Request.Browser.Browser.ToString() + " " + Request.Browser.Version.ToString() + " on " + Request.Browser.Platform.ToString(), fnt, sb, new Point(x, ((qq + 2) * 17) + 5));
        Response.ContentType = "image/jpeg";
        bitMapImage.Save(Response.OutputStream, ImageFormat.Jpeg);
        graphicImage.Dispose();
        bitMapImage.Dispose();
		sb.Dispose();
    }
    public String GetHtmlPage(string strURL)
    {
        String strResult;
        WebResponse objResponse;
        WebRequest objRequest = System.Net.HttpWebRequest.Create(strURL);
        objResponse = objRequest.GetResponse();
        using (StreamReader sr =
        new StreamReader(objResponse.GetResponseStream()))
        {
            strResult = sr.ReadToEnd();
            sr.Close();
        }
        return strResult;
    }
    public string hostnam()
    {
        System.Net.IPHostEntry ip = Dns.GetHostByAddress(Request.ServerVariables["REMOTE_HOST"].ToString());
        return (ip.HostName);
    }
    public string[] getSplitted(string quotes,string auth)
    {
        string[] splitted = new string[10];
        int cc = 0;
        int len;
        for (int i = 1; i < 10; i++)
        {
            if (i == 1)
            {
                len = 62;
            }
            else
            {
                len = 45;
            }
            if (cc + len < quotes.Length)
            {
                int kk = quotes.IndexOf(' ', cc + len);
                if (quotes.IndexOf(' ', cc + len) > 0)
                {
                    string temp = quotes.Substring(cc, ((quotes.IndexOf(' ', cc + len)) - cc));
                    if (temp != null)
                    {
                        splitted[i - 1] = temp;
                    }
                    else
                    {
                        splitted[i - 1] = "a";
                    }
                    cc = quotes.IndexOf(' ', cc + len);
                }
                else
                {
                    splitted[i-1] = quotes.Substring(cc);
                    splitted[i] = auth;
                    qq = i;
                    break;
                }
            }
            else
            {
                splitted[i - 1] = quotes.Substring(cc);
                splitted[i] = auth;
                qq = i;
                break;
            }
        }
        return (splitted);
    }

    private string[] GetQuotes()
    {
        DataSet ds = new DataSet();
        ds.ReadXml(dataSource);
        int cnt = ds.Tables[0].Rows.Count;
        ds.Dispose();
        Random RandomClass = new Random();
        int RandomNumber = RandomClass.Next(1, cnt);
        int i=1;
        string[] arr = new string[2];
		arr[0] = ds.Tables[0].Rows[RandomNumber]["Source"].ToString();
        arr[1] = ds.Tables[0].Rows[RandomNumber]["Contents"].ToString();
        return (getSplitted(arr[1],arr[0]));
    }
}

